import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Sierpinski extends JPanel {
 private int depth;

 public Sierpinski(int d) {
  depth = d;
  addMouseListener(new MouseAdapter() {
   public void mousePressed(MouseEvent e) {
    Object[] possibleValues = {"1","2","3","4","5","6","7","8","9","10"};
    String input = (String) JOptionPane.showInputDialog(
     Sierpinski.this,
     "Choose Depth",
     "Input",
     JOptionPane.QUESTION_MESSAGE,
     null,
     possibleValues,
     new Integer(depth).toString() 
    );
    if (input != null) setDepth(Integer.parseInt(input));
    repaint();
   }
  });
 }

 public void setDepth(int i) { depth = i; }

 public void sierpinski(int[] xs, int[] ys, Graphics g, int d) {
  if (d < 1) return;
  int l = xs.length;
  g.drawPolygon(xs,ys,l);
  for (int i = 0; i < l; ++i)
   sierpinski(
    new int[]{xs[i],(xs[i]+xs[(i+1)%l])/2,(xs[i]+xs[(i+2)%l])/2},
    new int[]{ys[i],(ys[i]+ys[(i+1)%l])/2,(ys[i]+ys[(i+2)%l])/2},
   g, d-1);
 }

 public void paintComponent(Graphics g) {
  super.paintComponent(g);
  int w = getWidth();
  int h = getHeight();
  sierpinski(new int[]{0,w,w/2}, new int[]{h,h,0}, g, depth);
 }

 public Dimension getPreferredSize() { return new Dimension(250,250); }

 public static void createAndShow() {
  JFrame f = new JFrame("Sierpinski Triangle");
  f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  f.add(new Sierpinski(5));
  f.pack();
  f.setVisible(true);
 }

 public static void main(String[] args) {
  SwingUtilities.invokeLater(new Runnable() {
   public void run() { createAndShow(); }
  });
 }
}
